﻿namespace Battleship.CollectionGenericObjects;

/// <summary>
/// Параметрированный набор объектов
/// </summary>
/// <typeparam name="T">Параметр: ограничение - ссылочный тип</typeparam>
public class MassiveGenericObjects<T> : ICollectionGenericObjects<T>
    where T : class
{
    /// <summary>
    /// Массив объектов, которые хранили
    /// </summary>
    private T?[] _collection;

    public int Count => _collection.Length;

    public int SetMaxCount { set { if (value > 0) { _collection = new T?[value]; } } }

    /// <summary>
    /// Конструктор
    /// </summary>
    public MassiveGenericObjects()
    {
        _collection = Array.Empty<T>();
    }

    public T? Get(int position)
    {
        //TODO проверка позиции
        if(position >= _collection.Length || position < 0)
        {
            return null;
        }
        return _collection[position];
    }

    public bool Insert(T obj)
    {
        //TODO вставка в свободное место набора
        int index = 0;
        while (index < _collection.Length)
        {
            if (_collection[index] == null)
            {
                _collection[index] = obj;
                return true;
            }
            index++;
        }
        return false;
    }

    public bool Insert(T obj, int position)
    {
        // TODO проверка позиции
        // TODO проверка, что элемент массива по этой позиции пустой, если нет, то
        //     ищется свободное место после этой позиции и идет вставка туда
        // TODO вставка
        if (position >= _collection.Length || position < 0)
            return false;

        while (position + 1 < _collection.Length)
        {
            if (_collection[position] == null)
            {
                _collection[position] = obj;
                return true;
            }
            position++;
        }

        while (position - 1 >= 0)
        {
            if (_collection[position] == null)
            {
                _collection[position] = obj;
                return true;
            }
            position--;
        }
        return false;

    }

    public bool Remove(int position)
    {
        // TODO проверка позиции
        // TODO удаление объекта из массива, присвоив элементу массива значение null
        if (position >= _collection.Length || position < 0)
        {
            return false;
        }
        _collection[position] = null;
        return true;
    }
}