﻿using Battleship.Drawings;

namespace Battleship.CollectionGenericObjects;

public class WarshipSharingService : AbstractCompany
{

    public WarshipSharingService(int picWidth, int picHeight, ICollectionGenericObjects<DrawingWarship> collection) : base(picWidth, picHeight, collection)
    {
    }

    protected override void DrawBackground(Graphics g)
    {
        Pen pen = new(Color.Black, 3);
        for (int i = 0; i <= _pictureWidth / _placeSizeWidth; i++)
        {
            for (int j = 0; j <= _pictureHeight / _placeSizeHeight; j++)
            {
                g.DrawLine(pen, i * _placeSizeWidth, j * _placeSizeHeight, i * _placeSizeWidth + _placeSizeWidth / 2, j * _placeSizeHeight);
            }
            g.DrawLine(pen, i * _placeSizeWidth, 0, i * _placeSizeWidth, _pictureHeight / _placeSizeHeight * _placeSizeHeight);
        }
    }

    protected override void SetObjectsPosition()
    {
        int width = _pictureWidth / _placeSizeWidth;
        int height = _pictureHeight / _placeSizeHeight;

        int posWidth = 0;
        int posHeight = height;

        for (int i = 0; i < (_collection?.Count ?? 0); i++)
        {
            if (_collection?.Get(i) != null)
            {
                _collection?.Get(i)?.SetPictureSize(_pictureWidth, _pictureHeight);
                _collection?.Get(i)?.SetPosition(_placeSizeWidth * posWidth + 4, posHeight * _placeSizeHeight + 4, width, height);
            }

            if (posWidth < width)
                posWidth++;
            else
            {
                posWidth = 0;
                posHeight--;
            }
            if (posHeight < 0)
            {
                return;
            }
        }
    }
}